c    "Copyright 2009 Prof. Robert Dalrymple, Prof. M. Gomez Gesteira, Dr Benedict Rogers, 
c     Dr Alejandro Crespo, Dr Muthukumar Narayanaswamy, Dr Shan Zou, Dr Andrea Panizzo "
c
c    This file is part of SPHYSICS.
c
c    SPHYSICS is free software; you can redistribute it and/or modify
c    it under the terms of the GNU General Public License as published by
c    the Free Software Foundation; either version 3 of the License, or
c    (at your option) any later version.
c
c    SPHYSICS is distributed in the hope that it will be useful,
c    but WITHOUT ANY WARRANTY; without even the implied warranty of
c    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c    GNU General Public License for more details.
c
c    You should have received a copy of the GNU General Public License
c    along with this program.  If not, see <http://www.gnu.org/licenses/>.

      subroutine divide(n_start,n_end,kind_p)
      include 'common.3D'

c
      do k=n_start,n_end	
      
        if (iflag(k).ne.0) then	
          dx = xp(k) - xmin
          dy = yp(k) - ymin
          dz = zp(k) - zmin

          icell = int( dx * one_over_2h ) + 1
          jcell = int( dy * one_over_2h ) + 1
          kcell = int( dz * one_over_2h ) + 1

          !if(i_periodicOBs(1).eq.1.and.icell.gt.ncx)icell=ncx   !Periodic Open Boundary correction X-Direction   
          if(i_periodicOBs(2).eq.1.and.jcell.gt.ncy)jcell=ncy    !Periodic Open Boundary correction Y-Direction   
          !if(i_periodicOBs(3).eq.1.and.kcell.gt.ncz)kcell=ncz   !Periodic Open Boundary correction Z-Direction   

          ! ii is the linear cell position in the matrix of 2h cells
          ii    = icell + (jcell - 1)*ncx +(kcell - 1)*nsheet   
          
          if(ii.lt.1)then
           write(80,*)' '
           write(80,*)'ERROR in divide_3D.f'
           write(80,*)'ii.lt.1'
           write(80,*)'itime',itime
           write(80,*)'kind_p       ',kind_p
           write(80,*)'nplink_max',nplink_max
           write(80,*)'n_start,n_end ',n_start,n_end
           write(80,*)'k',k
           write(80,*)'xp(k), yp(k), zp(k)',xp(k), yp(k), zp(k)
           write(80,*)'icell, jcell, kcell ',icell, jcell, kcell
           write(80,*)'Box ii ',ii
           write(80,*)'nc(ii,kind_p)',nc(ii,kind_p)
c          -- screen printout ---              
           write(*,*)' '
           write(*,*)'ERROR in divide_3D.f'
           write(*,*)'ii.lt.1'
           write(*,*)'itime',itime
           write(*,*)'kind_p       ',kind_p
           write(*,*)'nplink_max',nplink_max
           write(*,*)'n_start,n_end ',n_start,n_end
           write(*,*)'k',k
           write(*,*)'xp(k), yp(k), zp(k)',xp(k), yp(k), zp(k)
           write(*,*)'icell, jcell, kcell ',icell, jcell, kcell
           write(*,*)'Box ii ',ii
           write(*,*)'nc(ii,kind_p)',nc(ii,kind_p)
           stop
          end if

          ! nc is the number of particles in cell ii
          nc(ii,kind_p) = nc(ii,kind_p)+1	

          if(nc(ii,kind_p).gt.nplink_max)then
           write(80,*) ' '
           write(80,*)'ERROR in divide_3D.f'
           write(80,*)'nc(ii,kind_p) >= nplink_max'
           write(80,*)'itime',itime
           write(80,*)'nc(ii,kind_p)',nc(ii,kind_p)
           write(80,*)'kind_p       ',kind_p
           write(80,*)'nplink_max',nplink_max
           write(80,*)'k',k
           write(80,*)'xp(k), yp(k), zp(k)',xp(k), yp(k), zp(k)
           write(80,*)'icell, jcell, kcell ',icell, jcell, kcell
           write(80,*)'Box ii ',ii
c          -- screen printout ---              
           write(*,*) ' '
           write(*,*)'ERROR in divide_3D.f'
           write(*,*)'nc(ii,kind_p) >= nplink_max'
           write(*,*)'itime',itime
           write(*,*)'nc(ii,kind_p)',nc(ii,kind_p)
           write(*,*)'kind_p       ',kind_p
           write(*,*)'nplink_max',nplink_max
           write(*,*)'k',k
           write(*,*)'xp(k), yp(k), zp(k)',xp(k), yp(k), zp(k)
           write(*,*)'icell, jcell, kcell ',icell, jcell, kcell
           write(*,*)'Box ii ',ii
           stop
          end if
          
          ibox(ii,kind_p,nc(ii,kind_p))=k  !Tells us that particle with array location k (i.e. xp(k) )  
                                         !is in box ii which, so far, contains "nc(ii,mkind)" particles

        endif
     
      enddo 

      end