!arno start
      include 'vars_3D.f'
      ! move_ext_file
      !
      ! Moves particles according to the defined pattern/variables in gen
      subroutine move_ext_file
         
         use mv_vars
         include 'common.3D'
         real theta, thetap, dtheta, len_a, s,c, x_o,y_o,z_o,dir,t
         real x_n,y_n,z_n,t_o
         if(.not.allocated(mvs)) return
         if(mvs(size(mvs))%i_end.eq.-1)   mvs(size(mvs))%i_end=nbfm !avoids more getdata code, only done once
         do j = 1,size(mvs)
            if(time.lt.mvs(j)%mv_t0.or.mvs(j)%i_mv_type.eq.-1)then ! do not yet start or already finished
               return
            elseif(time.gt.mvs(j)%mv_t1)then ! first time that we are finished
               do i = mvs(j)%i_start,mvs(j)%i_end
                  up(i) = 0
                  vp(i) = 0
                  wp(i) = 0
               enddo
               mvs(j)%i_mv_type = -1
               return
            else
               t = time - mvs(j)%mv_t0
            endif
            
            
            if(mvs(j)%i_mv_type.eq.1)then
               do i=mvs(j)%i_start,mvs(j)%i_end
                  if(iflag(i).ne.0)then
                     xp(i)=xp(i) + mvs(j)%mv_ux*dt
                     yp(i)=yp(i) + mvs(j)%mv_uy*dt
                     zp(i)=zp(i) + mvs(j)%mv_uz*dt
                     up(i)=mvs(j)%mv_ux
                     vp(i)=mvs(j)%mv_uy
                     wp(i)=mvs(j)%mv_uz
                  endif
                  !destroy object if out of bounds (x,y,z-min,max)
                  if(xp(i).lt.xmin.or.xp(i).gt.xmax.or.yp(i).lt.ymin.or.
     &              yp(i).gt.ymax.or.zp(i).lt.zmin.or.zp(i).gt.zmax)then
                     iflag(i)=0
                     ncases=ncases+1
                     xp(i)=xtrash
                     yp(i)=ytrash
                     zp(i)=ztrash
                     up(i)=0.
                     vp(i)=0.
                     wp(i)=0.
                     um1(i)=0.
                     uo(i)=0.
                     vm1(i)=0.
                     vo(i)=0.
                     wm1(i)=0.
                     wo(i)=0.
                  endif
               enddo
            elseif(mvs(j)%i_mv_type.eq.2)then
               a = mvs(j)%mv_amp
               w = 2*pi/mvs(j)%mv_per
               c = mvs(j)%mv_pha*pi/180
               u_x = mvs(j)%mv_ux/sqrt(mvs(j)%mv_ux**2+mvs(j)%mv_uy**2+
     &                                 mvs(j)%mv_uz**2) !unit vector in moving direction
               u_y = mvs(j)%mv_uy/sqrt(mvs(j)%mv_ux**2+mvs(j)%mv_uy**2+
     &                                 mvs(j)%mv_uz**2)
               u_z = mvs(j)%mv_uz/sqrt(mvs(j)%mv_ux**2+mvs(j)%mv_uy**2+
     &                                 mvs(j)%mv_uz**2)
               do i=mvs(j)%i_start,mvs(j)%i_end
                  xp(i)=xp(i)+u_x*a*(sin(w*t+c)-sin(w*(t-dt)+c))
                  yp(i)=yp(i)+u_y*a*(sin(w*t+c)-sin(w*(t-dt)+c))
                  zp(i)=zp(i)+u_z*a*(sin(w*t+c)-sin(w*(t-dt)+c))
                  up(i)=u_x*a*w*cos(w*t+c)
                  vp(i)=u_y*a*w*cos(w*t+c)
                  wp(i)=u_z*a*w*cos(w*t+c)
               enddo
            elseif(mvs(j)%i_mv_type.eq.3)then
131            if(t.gt.mvs(j)%mv_per)then
                  t=t-mvs(j)%mv_per
                  goto 131
               endif
               dir = 1
               if(mvs(j)%mv_max_a.gt.mvs(j)%mv_min_a)then
                  ! calculate dtheta
                  len_a = mvs(j)%mv_max_a - mvs(j)%mv_min_a
                  thetap = len_a*2*(t-dt)/mvs(j)%mv_per-mvs(j)%mv_min_a
                  !thetap = thetap - floor(thetap/(len_a*2))
                  dtheta = len_a*2*dt/mvs(j)%mv_per
                  theta = thetap+dtheta
                  if(thetap.ge.len_a.and.theta.le.2*len_a)then
                     dtheta = -dtheta
                     dir = -1
                  elseif(thetap.lt.len_a.and.theta.gt.len_a)then
                     dtheta = len_a-thetap-(theta-len_a)
                     dir = -1
                  elseif(thetap.lt.2*len_a.and.theta.gt.2*len_a)then
                     dtheta = -(2*len_a-thetap-(theta-2*len_a))
                  endif
                  dtheta = dtheta*pi/180
               else ! mv_max_a < mv_min_a means constant rotation
                  dtheta = 2*pi*dt/mvs(j)%mv_per
               endif
               u_x = mvs(j)%mv_ux/sqrt(mvs(j)%mv_ux**2+mvs(j)%mv_uy**2+
     &                                 mvs(j)%mv_uz**2) !unit vector for rotation axis
               u_y = mvs(j)%mv_uy/sqrt(mvs(j)%mv_ux**2+mvs(j)%mv_uy**2+
     &                                 mvs(j)%mv_uz**2)
               u_z = mvs(j)%mv_uz/sqrt(mvs(j)%mv_ux**2+mvs(j)%mv_uy**2+
     &                                 mvs(j)%mv_uz**2)
               s = sin(dtheta)
               c = cos(dtheta)
               do i=mvs(j)%i_start,mvs(j)%i_end
                  ! shift to center
                  x_o = xp(i) - mvs(j)%mv_cx
                  y_o = yp(i) - mvs(j)%mv_cy
                  z_o = zp(i) - mvs(j)%mv_cz
                  ! rotate by dtheta and shift back
                  xp(i) = (u_x**2 + (1-u_x**2)*c) * x_o ! according to http://en.wikipedia.org/wiki/Rotation_matrix#Axis_of_a_rotation
                  xp(i) = (u_x*u_y*(1-c) - u_z*s) * y_o + xp(i)
                  xp(i) = (u_x*u_z*(1-c) + u_y*s)*z_o+xp(i)+mvs(j)%mv_cx
                  yp(i) = (u_x*u_y*(1-c) + u_z*s) * x_o
                  yp(i) = (u_y**2 + (1-u_y**2)*c) * y_o + yp(i)
                  yp(i) = (u_y*u_z*(1-c) - u_x*s)*z_o+yp(i)+mvs(j)%mv_cy
                  zp(i) = (u_x*u_z*(1-c) - u_y*s) * x_o
                  zp(i) = (u_y*u_z*(1-c) + u_x*s) * y_o + zp(i)
                  zp(i) = (u_z**2 + (1-u_z**2)*c)*z_o+zp(i)+mvs(j)%mv_cz

                  ! Velocity calculation
                  len_a = mvs(j)%mv_ux*(xp(1)-mvs(j)%mv_cx) + 
     &                  mvs(j)%mv_uy*(yp(1)-mvs(j)%mv_cy) + 
     &                 mvs(j)%mv_uz*(zp(1)-mvs(j)%mv_cz)
                  x_o = xp(i) - mvs(j)%mv_cx + mvs(j)%mv_ux*len_a ! particle - closest point on axis to the particle
                  y_o = yp(i) - mvs(j)%mv_cy + mvs(j)%mv_uy*len_a
                  z_o = zp(i) - mvs(j)%mv_cz + mvs(j)%mv_uz*len_a
                  up(i) = mvs(j)%mv_uy*z_o-mvs(j)%mv_uz*y_o ! axis vector cross (axis-particle) vector
                  vp(i) = mvs(j)%mv_uz*x_o-mvs(j)%mv_ux*z_o
                  wp(i) = mvs(j)%mv_ux*y_o-mvs(j)%mv_uy*x_o
                  len_a = dtheta/dt/sqrt(up(i)**2+vp(i)**2+wp(i)**2) ! norm cross, |v| = omega*r = dtheta/dt*r
     &                   * sqrt(x_o**2+y_o**2+z_o**2)
                  up(i) = up(i)*len_a*dir
                  vp(i) = vp(i)*len_a*dir
                  wp(i) = wp(i)*len_a*dir
               enddo     
            elseif(mvs(j)%i_mv_type.eq.4)then
               !linear interpolation old and new position
               if(mvs(j)%f_mv(if_mv,1).lt.time+dt) then
                  t_o = (time-mvs(j)%f_mv(mvs(j)%if_mv-1,1))/
     &                  (mvs(j)%f_mv(mvs(j)%if_mv,1)-
     &                  mvs(j)%f_mv(mvs(j)%if_mv-1,1))
                  x_o=mvs(j)%f_mv(mvs(j)%if_mv-1,2)+t_o*(
     &                mvs(j)%f_mv(mvs(j)%if_mv,2)-
     &                mvs(j)%f_mv(mvs(j)%if_mv-1,2))
                  y_o=mvs(j)%f_mv(mvs(j)%if_mv-1,3)+t_o*(
     &                mvs(j)%f_mv(mvs(j)%if_mv,3)-
     &                mvs(j)%f_mv(mvs(j)%if_mv-1,3))
                  z_o=mvs(j)%f_mv(mvs(j)%if_mv-1,4)+t_o*(
     &                mvs(j)%f_mv(mvs(j)%if_mv,4)-
     &                mvs(j)%f_mv(mvs(j)%if_mv-1,4))
                  mvs(j)%if_mv = mvs(j)%if_mv+1
                  t_o = (time+dt-mvs(j)%f_mv(mvs(j)%if_mv-1,1))/
     &                  (mvs(j)%f_mv(mvs(j)%if_mv,1)-
     &                  mvs(j)%f_mv(mvs(j)%if_mv-1,1))
                  x_n=mvs(j)%f_mv(mvs(j)%if_mv-1,2)+t_o*(
     &                mvs(j)%f_mv(mvs(j)%if_mv,2)-
     &                mvs(j)%f_mv(mvs(j)%if_mv-1,2))
                  y_n=mvs(j)%f_mv(mvs(j)%if_mv-1,3)+t_o*(
     &                mvs(j)%f_mv(mvs(j)%if_mv,3)-
     &                mvs(j)%f_mv(mvs(j)%if_mv-1,3))
                  z_n=mvs(j)%f_mv(mvs(j)%if_mv-1,4)+t_o*(
     &                mvs(j)%f_mv(mvs(j)%if_mv,4)-
     &                mvs(j)%f_mv(mvs(j)%if_mv-1,4))
                  !change:
                  mvs(j)%u_n = (x_n - x_o)/dt
                  mvs(j)%v_n = (y_n - y_o)/dt
                  mvs(j)%w_n = (z_n - z_o)/dt
                  mvs(j)%mv_update=1
               elseif(mvs(j)%mv_update.eq.1)then
                  t_o = mvs(j)%f_mv(mvs(j)%if_mv,1)-
     &                  mvs(j)%f_mv(mvs(j)%if_mv-1,1)
                  mvs(j)%u_n=(mvs(j)%f_mv(mvs(j)%if_mv,2)-
     &                        mvs(j)%f_mv(mvs(j)%if_mv-1,2))/t_o
                  mvs(j)%v_n=(mvs(j)%f_mv(mvs(j)%if_mv,3)-
     &                        mvs(j)%f_mv(mvs(j)%if_mv-1,3))/t_o
                  mvs(j)%w_n=(mvs(j)%f_mv(mvs(j)%if_mv,4)-
     &                        mvs(j)%f_mv(mvs(j)%if_mv-1,4))/t_o
                  mvs(j)%mv_update=0
               endif
               
               do i = mvs(j)%i_start,mvs(j)%i_end
                  xp(i) = xp(i)+mvs(j)%u_n*dt
                  yp(i) = yp(i)+mvs(j)%v_n*dt
                  zp(i) = zp(i)+mvs(j)%w_n*dt
                  up(i) = u_n
                  vp(i) = v_n
                  wp(i) = w_n
               enddo
            else
               write(*,*) ' Wrong i_mv_type variable. Stop '
               write(*,*) i_mv_type
               stop
            endif
         enddo
      
      end

      subroutine rpush(mv,i)
      use mv_vars
      type(mv_type) mv
      real, allocatable :: b(:,:)
      real, intent(in) :: i(:)
      if(.not.allocated(mv%f_mv)) then
         allocate(mv%f_mv(1,size(i)))
         mv%f_mv(1,:)=i(:)
      else
         allocate(b(size(mv%f_mv,1)+1,size(i)))
         b(1:size(mv%f_mv,1),:) = mv%f_mv(:,:)
         b(size(mv%f_mv,1)+1,:) = i(:)
         deallocate(mv%f_mv)
         allocate(mv%f_mv(size(b,1),size(i)))
         mv%f_mv = b
         deallocate(b)
      end if
      end subroutine
      
      subroutine read_mv_data()
         use mv_vars
         open(130,file="MULT_MV")
         read(130,*)i_mb
         allocate(mvs(i_mb))
         do i = 1,i_mb
            read(130,*) j
            mvs(i)%i_start=j
            if(i.ge.2) mvs(i-1)%i_end=j-1
         enddo
         mvs(i_mb)%i_end = -1 !will be set later
         !mvs(i_mb)%i_end = nbfm-1 !too early nbfm not defined yet
         do i = 1,i_mb
            ! read in data for movement behaviour
            read(130,*)mvs(i)%i_mv_type
            read(130,*)mvs(i)%mv_ux
            read(130,*)mvs(i)%mv_uy
            read(130,*)mvs(i)%mv_uz
            read(130,*)mvs(i)%mv_amp
            read(130,*)mvs(i)%mv_per
            read(130,*)mvs(i)%mv_pha
            read(130,*)mvs(i)%mv_cx
            read(130,*)mvs(i)%mv_cy
            read(130,*)mvs(i)%mv_cz
            read(130,*)mvs(i)%mv_min_a
            read(130,*)mvs(i)%mv_max_a
            read(130,*)mvs(i)%mv_t0
            read(130,*)mvs(i)%mv_t1

            if(mvs(i)%i_mv_type.eq.4)then !read in file
               write(mvs(i)%mv_file,"(i3)") mv_ux
               mvs(i)%mv_file = trim(mvs(i)%mv_file)
               mvs(i)%mv_file = "IMV_B."//mvs(i)%mv_file
               open(132,file=mvs(i)%mv_file)
               call rpush(mvs(i),(/0.,0.,0.,0./))
               do
                  read(132,*,end=133) t,x,y,z
                  call rpush(mvs(i),(/t,x,y,z/))
               enddo
133            close(132)
               mvs(i)%if_mv = size(mvs(i)%f_mv,1)
               call rpush(mvs(i),(/tmax+dt,
     &                    mvs(i)%f_mv(mvs(i)%if_mv,2),
     &                    mvs(i)%f_mv(mvs(i)%if_mv,3),
     &                    mvs(i)%f_mv(mvs(i)%if_mv,4)/))
               mvs(i)%if_mv = 2
               mvs(i)%mv_update = 1
               mvs(i)%mv_t1 = tmax
            endif     
         enddo
         close(130)
      end subroutine
!arno end
